unit UWinSkin;

interface

uses SysUtils,Windows,Messages,Classes,Graphics
     ,Controls,StdCtrls,ExtCtrls,Dialogs;

type
  TControlSubClass = class(TComponent)
   public
     ControlHandle:HWND;
     orgWindowProc:TWndMethod;
     SkinImage    :TBitmap;
     resourceImage:array[0..2] of TBitmap;
     ControlPtr   :TWinControl;
     ControlType  :string;
     Style        :integer;
     mdown,mmove  :boolean; //sA
     Constructor  Create(AOwner:TComponent); Override;
     Destructor   Destroy; Override;
     //----------------------------------------------------
     procedure DrawRadioButton(buttonState,extra:integer);
     procedure DrawCheckBox(buttonState,extra:integer);
     procedure DrawButton(buttonState,extra:integer);
     procedure TButtonMsg(Msg:LongWord);
     procedure TRadioButtonMsg(Msg:LongWord);
     procedure TCheckBoxMsg(Msg:LongWord);
     procedure ControlSubClass(var Msg:TMessage);
     procedure loadResourceImage;
     procedure initCanvas;
     procedure ReplaceWProc(inControl:TWinControl);
  end;

  TWinSkin = class(TCustomPanel)
  private
    myForm:TComponent;
    myControl:TStringList;
  public
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   ReSize; Override;
    procedure   Notification(AComponent:TComponent;Operation:TOperation); Override;
    //-----------------------------------------------------------------------------
    procedure SkinStart;
  end;

 procedure Register;

implementation

{$R UWinSkin.res}

procedure Register;
begin
  RegisterComponents('Win32',[TWinSkin]);
end;

//TControlSubClass.
procedure TControlSubClass.ControlSubClass(var Msg: TMessage);
begin
  if(ControlType = 'TButton' )then
    begin
      if(Msg.Msg = WM_PAINT)
         or (Msg.Msg = WM_MOUSEMOVE)  or (Msg.Msg = WM_LBUTTONDOWN)
         or (Msg.Msg = WM_LBUTTONUP)  or (Msg.Msg = WM_KEYDOWN)
         or (Msg.Msg = WM_KEYUP    )  or (Msg.Msg = WM_LBUTTONDBLCLK)
         or (Msg.Msg = CM_MOUSEENTER) or (Msg.Msg = CM_MOUSELEAVE)
         or (Msg.Msg = WM_ERASEBKGND) or (Msg.Msg = WM_NCPAINT)
         or (Msg.Msg = WM_SETFOCUS)   or (Msg.Msg = WM_KILLFOCUS)then
         begin
            orgWindowProc(Msg);
            TButtonMsg(Msg.Msg);
         end//if...end!!
       else orgWindowProc(Msg);  //LTdI
     end//if...end!!
   else
     if(ControlType = 'TRadioButton')then
       begin
         if(Msg.Msg = BM_SETCHECK)
            or (Msg.Msg = BM_GETCHECK)   or (Msg.Msg = WM_PAINT)
            or (Msg.Msg = WM_MOUSEMOVE)  or (Msg.Msg = WM_LBUTTONDOWN)
            or (Msg.Msg = WM_LBUTTONUP)  or (Msg.Msg = WM_KEYDOWN)
            or (Msg.Msg = WM_KEYUP)      or (Msg.Msg = WM_LBUTTONDBLCLK)
            or (Msg.Msg = CM_MOUSEENTER) or (Msg.Msg = CM_MOUSELEAVE)
            or (Msg.Msg = WM_ERASEBKGND) or (Msg.Msg = WM_NCPAINT)
            or (Msg.Msg = WM_SETFOCUS)then
           begin
             orgWindowProc(Msg);
             TRadioButtonMsg(Msg.Msg);
           end//if...end!!
         else orgWindowProc(Msg);  //LTdI
       end//if...end!!
     else
       if(ControlType = 'TCheckBox')then
         begin
           if(   Msg.Msg = BM_SETCHECK)
              or (Msg.Msg = BM_GETCHECK)   or (Msg.Msg = WM_PAINT)
              or (Msg.Msg = WM_MOUSEMOVE)  or (Msg.Msg = WM_LBUTTONDOWN)
              or (Msg.Msg = WM_LBUTTONUP)  or (Msg.Msg = WM_KEYDOWN)
              or (Msg.Msg = WM_KEYUP)      or (Msg.Msg = WM_LBUTTONDBLCLK)
              or (Msg.Msg = CM_MOUSEENTER) or (Msg.Msg = CM_MOUSELEAVE)
              or (Msg.Msg = WM_ERASEBKGND) or (Msg.Msg = WM_NCPAINT)
              or (Msg.Msg = WM_SETFOCUS)then
             begin
               orgWindowProc(Msg);
               TCheckBoxMsg(Msg.Msg);
             end//if...end!!
           else orgWindowProc(Msg);  //LTdI
         end//if...end!!
       else orgWindowProc(Msg); // DiSkin
end;

Constructor TControlSubClass.Create(AOwner: TComponent);
var i:integer;
begin
  inherited Create(AOwner);
  //إbmp
  Style := 0;
  mdown := false;
  mmove := false;
  SkinImage := TBitmap.Create;
  for i := 0 to 2 do
    resourceImage[i] := TBitmap.Create;
end;

Destructor TControlSubClass.Destroy;
var i:integer;
begin
  //٭챱즳 WinProc
  self.ControlPtr.WindowProc := self.orgWindowProc;
  self.orgWindowProc := nil;
  //-----------------------------------------------
  self.ControlPtr := nil;
  //-----------------------------------------------
  if(SkinImage <> nil)then FreeAndNil(SkinImage);
  for i := 0 to 2 do
    if(resourceImage[i] <> nil)then
     FreeAndNil(resourceImage[i]);
  inherited Destroy;
end;

procedure TControlSubClass.DrawButton(buttonState, extra: integer);
var i,j,k,outX,outY:integer;
    bmp:TBitmap;
begin
  bmp := resourceImage[buttonState];
  i := 0;
  while(i <= self.ControlPtr.Width)do
    begin
      j := 0;
      while(j <= self.ControlPtr.Height)do
        begin
          SkinImage.Canvas.CopyRect( Rect(i,j,i+12,j+12),bmp.Canvas,Rect(12,12,12+12,12+12));
          j := j+12;
        end;//while...end!!
      i := i+12;
    end;//while...i...end!!
  //--------------------------------------------------------------
  i := 0;
  while(i <= self.ControlPtr.Width)do
    begin
      SkinImage.Canvas.CopyRect( Rect(i,0,i+12 ,0+12),bmp.Canvas ,
                                Rect( 12 , 0 , 12+12 , 0+12 ) );
      i := i+12;
    end;//while...end!!
  //--------------------------------------------------------------------------------
  i := 0;
  while(i <= self.ControlPtr.Width)do
    begin
      SkinImage.Canvas.CopyRect( Rect(i,self.ControlPtr.Height-12,i+12,self.ControlPtr.Height)
                                ,bmp.Canvas,Rect(12,24,12+12,24+12));
      i := i+12;
    end;
  //--------------------------------------------------------------------------------
  i := 0;
  while(i <= self.ControlPtr.Height)do
    begin
      SkinImage.Canvas.CopyRect(Rect(0,i,12,i+12),bmp.Canvas,Rect(0,12,0+12,12+12));
      i := i+12;
    end;//while...end!!
  //--------------------------------------------------------------------------------
  i := 0;
  while(i <= self.ControlPtr.Height)do
    begin
      SkinImage.Canvas.CopyRect( Rect(self.ControlPtr.Width-12,i,self.ControlPtr.Width,i+12)
                                ,bmp.Canvas,Rect(24,12,24+12,12+12));
      i := i+12;
    end;//while...end!!
  //--------------------------------------------------------------------------------  
  SkinImage.Canvas.CopyRect(Rect(0,0,12,12),bmp.Canvas,Rect(0,0,12,12));
  SkinImage.Canvas.CopyRect( Rect(0,self.ControlPtr.Height-12,12,self.ControlPtr.Height)
                            ,bmp.Canvas,Rect(0,24,12,24+12));
  SkinImage.Canvas.CopyRect( Rect(self.ControlPtr.Width-12,0,self.ControlPtr.Width,12)
                            ,bmp.Canvas,Rect(24,0,24+12,12));
  SkinImage.Canvas.CopyRect( Rect( self.ControlPtr.Width-12,self.ControlPtr.Height-12
                                  ,self.ControlPtr.Width,self.ControlPtr.Height)
                            ,bmp.Canvas,Rect(24,24,24+12,24+12));
  //XӪr
  outX := (self.ControlPtr.Width  - SkinImage.Canvas.TextWidth (TButton(self.ControlPtr).Caption)) div 2;
  outY := (self.ControlPtr.Height - SkinImage.Canvas.TextHeight(TButton(self.ControlPtr).Caption)) div 2;
  if(buttonState = 2)then
    begin
      //sUɭԡArVkUʤ@I
      Inc(outX);
      Inc(outY);
    end;//if...end!!
  SkinImage.Canvas.Brush.Style := bsClear;
  if(buttonState=1)or(buttonState=2)then
    begin
      // eBJĪG
      SkinImage.Canvas.Font.Color := clWhite;
      SkinImage.Canvas.TextOut(outX+1,outY+1,TButton(self.ControlPtr).Caption);
    end;//if...end!!
  //Canvas.Brush.Style=bsClear;
  SkinImage.Canvas.Font := TButton(self.ControlPtr).Font;
  SkinImage.Canvas.Font.Color := clBlack;
  SkinImage.Canvas.TextOut(outX,outY,TButton(self.ControlPtr).Caption);
  if(extra=1)then
    begin
      SkinImage.Canvas.Pen.Color := RGB(230,230,230);
      SkinImage.Canvas.Rectangle(Rect(5,5,self.ControlPtr.Width-5,self.ControlPtr.Height-5));
    end;//if...end!!
  BitBlt( GetDC(self.ControlPtr.Handle),0,0
         ,self.ControlPtr.Width
         ,self.ControlPtr.Height,SkinImage.Canvas.Handle,0,0,SRCCOPY);
end;

procedure TControlSubClass.DrawCheckBox(buttonState, extra: integer);
var i,j,k:integer;
    bmp:TBitmap;
begin
  bmp := resourceImage[buttonState];
  SkinImage.Canvas.Brush.Color := TCheckBox(self.ControlPtr).Color;
  SkinImage.Canvas.FillRect(Rect(0,0,self.ControlPtr.Width,self.ControlPtr.Height));
  SkinImage.Canvas.CopyRect( Rect(0,0, bmp.Width-3 ,bmp.Height-3)
                            ,bmp.Canvas ,Rect(0,0,bmp.Width ,bmp.Height));
  BitBlt( GetDC(self.ControlPtr.Handle)
         ,0
         ,(self.ControlPtr.Height div 2)-10
         ,bmp.Width-3,bmp.Height-3,SkinImage.Canvas.Handle,0,0,SRCCOPY);
end;

procedure TControlSubClass.DrawRadioButton(buttonState,extra:integer);
var i,j,k:integer;
    bmp:TBitmap;
begin
  bmp := resourceImage[buttonState];
  SkinImage.Canvas.Brush.Color := TRadioButton(self.ControlPtr).Color;
  SkinImage.Canvas.FillRect(Rect(0,0,self.ControlPtr.Width,self.ControlPtr.Height));
  SkinImage.Canvas.CopyRect( Rect(0,0, bmp.Width ,bmp.Height)
                            ,bmp.Canvas
                            ,Rect(0,0,bmp.Width ,bmp.Height));
  BitBlt( GetDC(self.ControlPtr.Handle)
         ,0
         ,(self.ControlPtr.Height div 2)-8
         ,bmp.Width,bmp.Height,SkinImage.Canvas.Handle,0,0,SRCCOPY);
end;

procedure TControlSubClass.initCanvas;
var rethRgn:HRGN;
begin
  SkinImage.Width  := self.ControlPtr.Width;
  SkinImage.Height := self.ControlPtr.Height;
  loadResourceImage();
  if(ControlType = 'TButton')then
    begin
      // trick:
      Style := 1;
      //el
      if(Style = 0)then
        begin
          rethRgn := 0;
          DrawButton(0,0);
          rethRgn := CreateRoundRectRgn(0,0,self.ControlPtr.Width+1
                                           ,self.ControlPtr.Height+1,12,12);
          SetWindowRgn(self.ControlPtr.Handle ,rethRgn,True);
        end//if...end!!
      else
        if(Style = 1)then
          begin
            rethRgn := 0;
            DrawButton(0,0);
            rethRgn := CreateRoundRectRgn(0,0,self.ControlPtr.Width+1
                                             ,self.ControlPtr.Height+1,0,0);
            SetWindowRgn(self.ControlPtr.Handle,rethRgn,True);
          end;//if...end!!
    end//if...end!!
  else
    if(ControlType = 'TRadioButton')then
      if(Style = 0)then DrawRadioButton(0,0)
    else
      if(ControlType = 'TCheckBox')then
        if(Style = 0)then DrawCheckBox(0,0);
end;

procedure TControlSubClass.loadResourceImage;
var i:integer;
begin
  if(ControlType = 'TButton')then
    begin
      for i := 0 to 2 do
        begin
          if(Style = 0)then
            resourceImage[i].LoadFromResourceName(HInstance,'macOS'+IntToStr(i))
          else
            if(Style = 1)then
             resourceImage[i].LoadFromResourceName(HInstance,'blueEnergy'+IntToStr(i));
        end;//for...i...end!!
    end//if...end!!
  else
    if(ControlType = 'TRadioButton')then
      begin
          for i := 0 to 1 do
            begin
              if(Style = 0)then
                resourceImage[i].LoadFromResourceName(HInstance,'macOSRadio'+IntToStr(i));
            end;//for...i...end!!
      end//if...end!!
    else
      if(ControlType = 'TCheckBox')then
        for i := 0 to 2 do
          begin
            if(Style = 0)then
              resourceImage[i].LoadFromResourceName(HInstance,'macOSCheck'+IntToStr(i));
          end;//for...i...end!!
end;

procedure TControlSubClass.ReplaceWProc(inControl:TWinControl);
begin
  //WindowProc var oldProc: TWndMethod
  orgWindowProc := inControl.WindowProc;
  inControl.WindowProc := ControlSubClass;
end;

procedure TControlSubClass.TButtonMsg(Msg:LongWord);
begin
  case Msg of
    WM_MOUSEMOVE:
      begin
        // failed ?
        //DrawButton(1,0);
        mmove := true;
      end;
    WM_LBUTTONDOWN:
      begin
        DrawButton(2,1);
        mdown := true;
      end;
    WM_LBUTTONUP:
      begin
        DrawButton(1,0);
        mdown := false;
      end;
    WM_KEYDOWN:
      begin
        DrawButton(2,1);
        mdown := true;
      end;
    WM_KEYUP:
      begin
        DrawButton(1,1);
        mdown := false;
      end;
    CM_MOUSELEAVE:
      begin
        DrawButton(0,0);
        mmove := false;
        mdown := false;
      end;
    WM_PAINT:
      begin
        //ݯSOBzA
        if(mdown = TRUE)then DrawButton(2,1)
        else
          if(mmove = TRUE)then DrawButton(1,0)
          else DrawButton(0,0);
      end;
    CM_MOUSEENTER:
      begin
        DrawButton(1,0);
        mmove := true;
      end;
    WM_LBUTTONDBLCLK:DrawButton(1,1);
    WM_ERASEBKGND   :DrawButton(0,0);
    WM_NCPAINT      :DrawButton(0,0);
    WM_SETFOCUS:
      begin
        //ݭne@focus rect
        DrawButton(1,1);
      end
    else DrawButton(0,0);
  end;//case...end!!
end;

procedure TControlSubClass.TCheckBoxMsg(Msg: LongWord);
begin
  case Msg of
    WM_MOUSEMOVE:
      begin
        if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
          DrawCheckBox(0,0)
        else
          if(TCheckBox(self.ControlPtr).State = cbChecked)then
            DrawCheckBox(1,0)
          else DrawCheckBox(2,0);
        mmove := true;
      end;
    WM_LBUTTONDOWN:
      begin
        if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
          DrawCheckBox(0,0)
        else
          if(TCheckBox(self.ControlPtr).State = cbChecked)then
            DrawCheckBox(1,0)
          else DrawCheckBox(2,0);
        mdown := true;
      end;
    WM_LBUTTONUP:
      begin
        if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
          DrawCheckBox(0,0)
        else
          if(TCheckBox(self.ControlPtr).State = cbChecked)then
            DrawCheckBox(1,0)
          else DrawCheckBox(2,0);
        mdown := false;
      end;
    WM_KEYDOWN:
      begin
        if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
          DrawCheckBox(0,0)
        else
          if(TCheckBox(self.ControlPtr).State = cbChecked)then
            DrawCheckBox(1,0)
          else DrawCheckBox(2,0);
        mdown := true;
      end;
    WM_KEYUP:
      begin
        if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
          DrawCheckBox(0,0)
        else
          if(TCheckBox(self.ControlPtr).State = cbChecked)then
            DrawCheckBox(1,0)
          else DrawCheckBox(2,0);
        mdown := false;
      end;
    CM_MOUSELEAVE:
      begin
        if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
          DrawCheckBox(0,0)
        else
          if(TCheckBox(self.ControlPtr).State = cbChecked)then
            DrawCheckBox(1,0)
          else DrawCheckBox(2,0);
        mmove := false;
        mdown := false;
      end;
    WM_PAINT:
      begin
        if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
          DrawCheckBox(0,0)
        else
          if(TCheckBox(self.ControlPtr).State = cbChecked)then
            DrawCheckBox(1,0)
          else DrawCheckBox(2,0);
      end;
    CM_MOUSEENTER:
      begin
        if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
          DrawCheckBox(0,0)
        else
          if(TCheckBox(self.ControlPtr).State = cbChecked)then
            DrawCheckBox(1,0)
          else DrawCheckBox(2,0);
        mmove := true;
      end;
    WM_LBUTTONDBLCLK:
      begin
       if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
         DrawCheckBox(0,0)
       else
         if(TCheckBox(self.ControlPtr).State = cbChecked)then
           DrawCheckBox(1,0)
         else DrawCheckBox(2,0);
      end;
    WM_ERASEBKGND:
      begin
        if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
          DrawCheckBox(0,0)
        else
          if(TCheckBox(self.ControlPtr).State = cbChecked)then
            DrawCheckBox(1,0)
          else DrawCheckBox(2,0);
      end;
    WM_NCPAINT:
      begin
        if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
          DrawCheckBox(0,0)
        else
          if(TCheckBox(self.ControlPtr).State = cbChecked)then
            DrawCheckBox(1,0)
          else DrawCheckBox(2,0);
      end;
    WM_SETFOCUS:
      begin
        if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
          DrawCheckBox(0,0)
        else
          if(TCheckBox(self.ControlPtr).State = cbChecked)then
            DrawCheckBox(1,0)
          else DrawCheckBox(2,0);
      end
    else
      if(TCheckBox(self.ControlPtr).State = cbUnchecked)then
        DrawCheckBox(0,0)
      else
        if(TCheckBox(self.ControlPtr).State = cbChecked)then
          DrawCheckBox(1,0)
        else DrawCheckBox(2,0);
  end;//case...end!!      
end;

procedure TControlSubClass.TRadioButtonMsg(Msg: LongWord);
begin
  //mdown=false,mmove=false; //sA
  case Msg of
     WM_MOUSEMOVE:
       begin
         if(not TRadioButton(self.ControlPtr).Checked)then
           DrawRadioButton(0,0)
         else DrawRadioButton(1,0);
         mmove := true;
       end;
     WM_LBUTTONDOWN:
       begin
         if(not TRadioButton(self.ControlPtr).Checked)then
           DrawRadioButton(0,0)
         else DrawRadioButton(1,0);
         mdown := true;
       end;
     WM_LBUTTONUP:
       begin
         if(not TRadioButton(self.ControlPtr).Checked)then
           DrawRadioButton(0,0)
         else DrawRadioButton(1,0);
         mdown := false;
       end;
     WM_KEYDOWN:
       begin
         if(not TRadioButton(self.ControlPtr).Checked)then
           DrawRadioButton(0,0)
         else DrawRadioButton(1,0);
         mdown := true;
       end;
     WM_KEYUP:
       begin
         if(not TRadioButton(self.ControlPtr).Checked)then
           DrawRadioButton(0,0)
         else DrawRadioButton(1,0);
         mdown := false;
       end;
     CM_MOUSELEAVE:
       begin
         if(not TRadioButton(self.ControlPtr).Checked)then
           DrawRadioButton(0,0)
         else DrawRadioButton(1,0);
         mmove := false;
         mdown := false;
       end;
     WM_PAINT:
       begin
         if(not TRadioButton(self.ControlPtr).Checked)then
           DrawRadioButton(0,0)
         else DrawRadioButton(1,0);
       end;
     CM_MOUSEENTER:
       begin
         if(not TRadioButton(self.ControlPtr).Checked)then
           DrawRadioButton(0,0)
         else DrawRadioButton(1,0);
         mmove := true;
       end;
     WM_LBUTTONDBLCLK:
       begin
         if(not TRadioButton(self.ControlPtr).Checked)then
           DrawRadioButton(0,0)
         else DrawRadioButton(1,0);
       end;
     WM_ERASEBKGND:
       begin
         if(not TRadioButton(self.ControlPtr).Checked)then
           DrawRadioButton(0,0)
         else DrawRadioButton(1,0);
       end;
     WM_NCPAINT:
       begin
         if(not TRadioButton(self.ControlPtr).Checked)then
           DrawRadioButton(0,0)
         else DrawRadioButton(1,0);
       end;
     WM_SETFOCUS:
       begin
         if(not TRadioButton(self.ControlPtr).Checked)then
           DrawRadioButton(0,0)
         else DrawRadioButton(1,0);
       end;
     else
       if(not TRadioButton(self.ControlPtr).Checked)then
         DrawRadioButton(0,0)
       else DrawRadioButton(1,0);
  end;//case...end!!
end;

//TWinSkin
Constructor TWinSkin.Create(AOwner: TComponent);
var i:integer;
begin
  inherited Create(AOwner);
  self.Caption := 'WinSkin';
  self.Width   := 25;
  self.Height  := 25;
  myForm       := AOwner;
  myControl    := TStringList.Create;
  if(csDesigning in self.ComponentState)then
    self.Visible := TRUE
  else self.Visible := FALSE;
end;

Destructor TWinSkin.Destroy;
var i:integer;
begin
  self.myForm := nil;
  for i := 0 to self.myControl.Count-1 do
    if(self.myControl.Objects[i] <> nil)then
      begin
        TControlSubClass(self.myControl.Objects[i]).Free;
        self.myControl.Objects[i] := nil;
      end;//if...end!!
  //------------------------------------------------------
  self.myControl.Clear;
  FreeAndNil(self.myControl);
  inherited Destroy;
end;

procedure TWinSkin.Notification(AComponent: TComponent; Operation: TOperation);
var i,id:integer;
begin
  inherited Notification(AComponent,Operation);
  if(Operation = opRemove)then
    begin
      id := -1;
      if(self.myControl <> nil)then
      for i := 0 to self.myControl.Count-1 do
        begin
          if(TControlSubClass(self.myControl.Objects[i]).ControlPtr = AComponent)then
            begin
              id := i;
              TControlSubClass(self.myControl.Objects[i]).Free;
              self.myControl.Objects[i] := nil;
              Break;
            end;//if...end!!
        end;//for...i...end!!
      //---------------------------------------------
      if(id >= 0)then self.myControl.Delete(id);
    end;//if...end!!
  if(AComponent <> self)and(Operation = opInsert)then self.SkinStart;
end;

procedure TWinSkin.ReSize;
begin
  self.Width  := 25;
  self.Height := 25;
  self.SkinStart;
end;

procedure TWinSkin.SkinStart;
var i:integer;
    tmpSubClass:TControlSubClass;
    procedure ReShapeControls;
    begin
      if(tmpSubClass <> nil)then
        if(tmpSubClass.ControlPtr <> nil)then
          begin
            self.myControl.AddObject(tmpSubClass.ControlPtr.Name,tmpSubClass);
            tmpSubClass.initCanvas();
            tmpSubClass.ReplaceWProc(tmpSubClass.ControlPtr);
            tmpSubClass.ControlPtr.DoubleBuffered := true;
            tmpSubClass.ControlPtr.Repaint();
            tmpSubClass := nil;
          end;//if...end!!
    end;
begin
  for i := 0 to myForm.ComponentCount-1 do
    begin
      if(trim(myForm.Components[i].Name) = '')then Continue;
      if(self.myControl.IndexOfObject(myForm.Components[i]) >= 0)then Continue;
      //----------------------------------------------------------------------
      if(myForm.Components[i].ClassType = TButton)then
        begin
          tmpSubClass := TControlSubClass.Create(nil);
          tmpSubClass.ControlPtr  := TButton(myForm.Components[i]);
          tmpSubClass.ControlType := 'TButton';
          ReShapeControls;
          Continue;
        end;//if...end!!
      if(myForm.Components[i].ClassType = TRadioButton)then
        begin
          tmpSubClass := TControlSubClass.Create(nil);
          tmpSubClass.ControlPtr  := TRadioButton(myForm.Components[i]);
          tmpSubClass.ControlType := 'TRadioButton';
          ReShapeControls;
          Continue;
        end;//if...end!!
      if(myForm.Components[i].ClassType = TCheckBox)then
        begin
          tmpSubClass := TControlSubClass.Create(nil);
          tmpSubClass.ControlPtr  := TCheckBox(myForm.Components[i]);
          tmpSubClass.ControlType := 'TCheckBox';
          ReShapeControls;
          Continue;
        end;//if...end!!
    end;//for...i...end!!
end;

end.
